jQuery.plugin( "ep.ui.magnifier", {
	plugin: ["ep.ui.core", "jQuery.fn.size", "jQuery.tmpl", "jQuery.ui.widget", "jQuery.event.special.load", "ep.fn.contextOrientation", "ep.dict"],
  dict: ["ep.dict"],
	tmpl:	["ep.ui.magnifier"]
}, function( $, undefined ){

  tExpand = ep.dict("ep.dict").translate("Expand");

	$.widget("ep.ui.Magnifier", {
		options: {
		//	action			: "lightbox",		//
			images			: "img",			// selector / array of data / data / image node / array of image nodes / jQuery object
			orientation		: "right",
			width			: 250,
			height			: 250
		},

		_create: function(){
			var self = this,
				o = self.options,
				imgs = self.images = ep.ui.imgData(o.images)
					.on("change.uiMagnifier", self.Proxy("_change") );

			self.animating = false;
			self.refresh = false;

			// load template and add element names to instance
			$.extend( self, $.tmpl( "ep.ui.magnifier", [{expand:tExpand}] ).appendTo(self.element).tmplItem("elements") );

			self.cache = {
				box		: {
					width: self.box.innerWidth(),
					height: self.box.innerHeight()
				},
				boxMag	: {},
				ratio	: {}
			};

			self.zoom.appendTo("body");

			self.container
				.on("click.uiMagnifier", function(event){
					if( o.action ){
						imgs.trigger(o.action);
					}
				});

			self._setOptions(o);
		},

		_init: function(){
			this._change();
		},

		destroy: function(){
			var self = this;

			self.images.off(".uiMagnifier");
			self.zoom.remove();
			self.container.remove();
			self.Inherited(arguments);
		},

		_setOption: function( key, value ) {
			var self = this;

			if ( key === "action" ) {
				self.container.css("cursor", value ? "pointer" : "");
			}
			else if ( key === "width" ) {
				self.zoom.width(value);
			}
			else if ( key === "height" ) {
				self.zoom.height(value);
			}

			return this.Inherited(arguments);
		},

		_change: function(){
			var self	= this;

			if( self.animating ){
				self.refresh = true;
			}
			else{
				var o			= self.options,
					boxWidth	= self.cache.box.width,
					boxHeight	= self.cache.box.height,
					curr		= self.images.current(),
					imgSrc		= curr.srcM,
					img,
					zoom,
					check,
					doCheck = false;

				if( boxWidth > 200 || boxHeight > 200 ){
					check = curr.srcL;
					doCheck = true;
				}
				else if( (boxWidth > 100 && boxWidth < 200) || (boxHeight > 100 && boxHeight < 200) ){
					check = curr.srcS;
					doCheck = true;
				}
				else if( boxWidth <= 100 || boxHeight <= 100 ){
					check = curr.srcXS;
					doCheck = true;
				}

				if(doCheck){
					var checkName = check.replace(/(_\w)?\..*?$/ig,"");
					var imgName = imgSrc.replace(/(_\w)?\..*?$/ig,"");
					if(checkName && imgName && checkName == imgName){
						imgSrc	= check;
					}
				}

				self.refresh = false;
				self.animating = true;

				self.zoom.hide();
				self.container
					.off("mouseenter.uiMagnifier mousemove.uiMagnifier mouseleave.uiMagnifier");

				img = $('<img alt="" src="'+imgSrc+'"/>')
					.appendTo(self.boxWrap.empty().hide())
					.on("load", function(){
						ep.ui.imgCenter( img, true );

						self.boxWrap.show();

						if( self.refresh ){
							self.animating = false;
							self._change();
						}
						else{
							zoom = $('<img alt="" src="'+self.images.current().srcL+'"/>')
								.appendTo(self.zoomWrap.empty())
								.on("load", function(){
									self.animating = false;

									if( self.refresh ){
										self._change();
									}
									else{
										self._resizeZoom();
										self.container
											.on("mouseenter.uiMagnifier",self.Proxy("_enterMag"))
											.on("mousemove.uiMagnifier",self.Proxy("_moveMag"))
											.on("mouseleave.uiMagnifier",self.Proxy("_leaveMag"));
									}
								});
						}
					});

			}
		},

		_resizeZoom: function(){
			var self			= this,

				o				= self.options,
				cache			= self.cache,

				boxWrap			= self.boxWrap.find("img"),
				zoomWrap		= self.zoomWrap.find("img").appendTo("body"), // IE: make img visible to get size

				zoomWrapWidth,
				zoomWrapHeight,

				zoomImgWidth	= zoomWrap[0].width,
				zoomImgHeight	= zoomWrap[0].height,

				boxWrapWidth	= self.boxWrap.innerWidth(),
				boxWrapHeight	= self.boxWrap.innerHeight(),

				boxImgWidth		= boxWrap[0].width,
				boxImgHeight	= boxWrap[0].height;

			// IE: put img back
			zoomWrap.appendTo(self.zoomWrap);

			if( zoomImgWidth - boxWrapWidth >= zoomImgHeight - boxWrapHeight ){
				zoomWrapWidth = zoomImgWidth;
				zoomWrapHeight = zoomImgWidth * boxWrapHeight / boxWrapWidth;
			}
			else{
				zoomWrapWidth = zoomImgHeight * boxWrapWidth / boxWrapHeight;
				zoomWrapHeight = zoomImgHeight;
			}

			self.zoomWrap
				.width( zoomWrapWidth )
				.height( zoomWrapHeight );

			self.boxMag
				.outerWidth(  cache.boxMag.width  = Math.min(boxWrapWidth , boxWrapWidth  * o.width  / zoomWrapWidth ) )
				.outerHeight( cache.boxMag.height = Math.min(boxWrapHeight, boxWrapHeight * o.height / zoomWrapHeight) );

			cache.box.width = self.box.innerWidth();
			cache.box.height = self.box.innerHeight();

			cache.ratio.X = zoomWrapWidth / boxWrapWidth;
			cache.ratio.Y = zoomWrapHeight / boxWrapHeight;

			ep.ui.imgCenter( zoomWrap, false );

			self.zoom
				.width( Math.min(o.width, zoomWrapWidth) )
				.height( Math.min(o.height, zoomWrapHeight) );
		},

		_enterMag: function(){
			var self = this;
			self.boxMag
				.show();

			self.zoom
				.contextOrientation(self.container, self.options.orientation,[10,0])
				.show();
		},

		_moveMag: function( event ){
			var self	= this,
				cache		= self.cache,
				offset	= self.box.offset(),
				top			= Math.ceil( Math.min( Math.max(0, (event.pageY - offset.top) - cache.boxMag.height/2), cache.box.height - cache.boxMag.height ) ),
				left		= Math.ceil( Math.min( Math.max(0, (event.pageX - offset.left) - cache.boxMag.width/2), cache.box.width - cache.boxMag.width ) ),
				img			= self.zoomWrap.find('img');

			self.boxMag
				.css({
					top: top + "px",
					left: left + "px"
				});

			self.zoomWrap
				.css({
					top: -(top * cache.ratio.Y) + "px",
					left: -(left * cache.ratio.X) + "px"
				})
				// IE: reset top/left
				.find("img")
					.css({
						top : self.zoomWrap.height()/2 - img.height()/2,
						left: self.zoomWrap.width()/2 - img.width()/2
					});
		},

		_leaveMag: function(){
			var self = this;
			self.boxMag.hide();
			self.zoom.hide();
		}

	});

});